unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

  noeud = class
  private
     carac : char ;
     gauche,droite : noeud ;
     constructor create(c : char) ;
     destructor  destroy ;
     procedure   creer(nb,niv : integer) ;
     procedure   afficher(x,y,l : integer) ;
  end ;

  arbre = class
  private
     tete,courant : noeud ;
  public
     constructor create(c : char) ;
     destructor  destroy ;
     procedure   afficher(x,y,l : integer) ;
  end ;

const st : string = ' EISHVUF ARL WPJTNDBXKCYMGZQO  ' ;

var
  Form1: TForm1;
  morse : arbre ;

implementation

{$R *.DFM}

constructor noeud.create(c : char) ;
begin
carac:=c ;
gauche:=nil ;droite:=nil ;
end ;

destructor noeud.destroy ;
begin
if gauche<>nil then gauche.destroy ;
if droite<>nil then droite.destroy ;
end ;

procedure noeud.afficher(x,y,l : integer) ;
begin
with form1.image1.picture.bitmap.canvas do
   begin
   ellipse(x,y,x+25,y+25) ;
   textOut(x+5,y+5,carac) ;
   if gauche<>nil then
      begin
      moveto(x+3,y+20) ;lineto(x-(l div 2)+10,y+70) ;
      gauche.afficher(x-(l div 2),y+60,l div 2) ;
      end ;
   if droite<>nil then
      begin
      moveto(x+22,y+20) ;lineto(x+(l div 2)+10,y+70) ;
      droite.afficher(x+(l div 2),y+60,l div 2) ;
      end ;
   end ;
end ;

procedure noeud.creer(nb,niv : integer) ;
var i : integer ;
begin
if niv<5 then
   begin
   gauche:=noeud.create(st[nb+1]) ;
   gauche.creer(nb+1,niv+1) ;
   i:=nb+(round(exp((5-niv)*ln(2)))) ;
   droite:=noeud.create(st[i]) ;
   droite.creer(i,niv+1) ;
   end ;
end ;

//--------------------------------------
constructor arbre.create(c : char) ;
begin
tete:=noeud.create(c) ;
courant:=tete ;
end ;

destructor arbre.destroy ;
begin
courant:=nil ;
tete.destroy ;
end ;

procedure arbre.afficher(x,y,l : integer) ;
begin
tete.afficher(x,y,l) ;
end ;

//--------------------------------------


procedure TForm1.FormCreate(Sender: TObject);
begin
morse:=nil ;
image1.picture.bitmap:=tbitmap.create ;
with image1.picture.bitmap do
   begin
   width:=639 ;height:=500 ;
   end ;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
morse:=arbre.create(' ') ;
morse.tete.creer(1,1) ;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
morse.afficher(image1.width div 2 -10, 10 , image1.width div 2) ;
end;

end.
